//package controllers.MyController;

//package controllers;

import competition.GhostsController;
import core.*;
import core.maze.*;
import core.utilities.*;
import controllers.*;

import java.util.*;

public class MyGhostsTeamBot implements GhostsController, Constants {
	
	public static final int maxData = 21;
		
	MazeInterface maze;
	JunctionNode[] juncs;
	List<TreeNode>[] roots; //They maybe become next start point in the next time slice of each ghost
	//int[] rootId; //The Idex of each root in list of available roots for each ghost
	List<TreeNode>[] trees; //The move of each ghost
	TreeNode nextTNode[]; //An array store the next cross-point tree node the ghost will visit	
	MCTThread[] mctThread;
	Thread mainThread;
	//int startDirs[];
	
	NodeScore[] scorers;
    //ArrayList<Node> options;
    
    //PacInfo[] infoCollector;
    PacInfo infoCollector;
    LinkedList<VectorND> sampleData, procData;
    GameStateInterface preGS = null, pretGS = null;
    Node expectPac;
    //KNNAgent[] pseuAgent;
    //double trustLvl[] = {1.0, 1.0, 1.0, 1.0};
    double trustLvl = 1.0;
    int allTimes, falseTimes;
    //int expectDir = NEUTRAL;
    //ElapsedTimer t = new ElapsedTimer();
	
    // Make more thread to increase performance
    // At which condition the simulation's finished? Make my own simGame
    
	@Override
	public int[] getActions(GameStateInterface gs) {
		// TODO Auto-generated method stub
		int[] dirs = new int[nGhosts];
		if (!gs.getMaze().equals(maze)) { 
			setMaze(gs.getMaze());
			resetAll();
		} else if (pretGS != null){
			// If the position between preGS and current GS is changed, obviously the game was restarted.
			boolean check;
			check = gs.getMaze().dist(pretGS.getPacman().current, gs.getPacman().current) > 4;
			for (int i = 0; i < nGhosts; i++) check |= gs.getMaze().dist(pretGS.getGhosts()[i].current, gs.getGhosts()[i].current) > 4;
			if (check) {
				//if (allTimes != 0 )System.out.println(1.0-1.0*falseTimes/allTimes);
				resetAll();
			}
			
		}
		pretGS = gs.copy();
		
		// K-NN
		Node pac = gs.getPacman().current;
		if (pac.x % 4 == 3 && pac.y % 4 == 1){
			if (sampleData == null) sampleData = new LinkedList<VectorND>();
			if (procData == null) procData = new LinkedList<VectorND>();
			VectorND curStat = infoCollector.getInfo(gs);
			if (preGS != null && sampleData.size() > 0){
				try {
					if (procData.size() >= maxData - 1) procData.pollFirst();
					VectorND tmp = VectorND.sub(infoCollector.getInfo(preGS, gs.getPacman().current), sampleData.getLast());
					procData.add(tmp);
					//if(tmp.elements[PacInfo.d2NPi] != -4)
					//	System.out.print("Fck");
					//procData[i].getLast().normallize();
				} catch (Exception e){
					System.out.println(e);
				}
			}
			if (sampleData.size() >= maxData) sampleData.pollFirst();
			sampleData.add(curStat);
				//if (sampleData[i].size() > maxData) throw new RuntimeException("ABC");
			
			preGS = pretGS;
		}
		
		//MCT selection
		for (int i = 0; i < nGhosts; i++) {
			Ghosts curGhost = gs.getGhosts()[i];
			// for the first ghost, move to trap pacman
			if (i == 0){
				//dirs[i] = getDefaultDir(gs, i);
				boolean inverse = false;
				Node target = pac;
				Node pre = null;
				for (Node n : pac.adj){
					if (Utilities.getWrappedDirection(n, pac, gs.getMaze()) == gs.getPacman().curDir){
						pre = n;
						break;
					}
				}
				if (pre != null) 
					while (target.adj.size() < 3) {
						for(Node n : target.adj) if (n != pre) { pre = target; target = n; break; }
						if (!inverse){
							for (int j = 0; j < nGhosts; j++) if (j != i && target == gs.getGhosts()[j].current){
								Node tmp = target;
								target = pre;
								pre = tmp;
								inverse = true;
							}
						}
					}
				ArrayList<Node> options = new ArrayList<Node>();
				for (Node n : curGhost.current.adj) if(n != curGhost.previous) options.add(n);
				if (pre != null && !curGhost.edible() || curGhost.edibleTime < maze.dist(curGhost.current, gs.getPacman().current) / 3.0 ){
					double best = Double.MAX_VALUE;
					Node sel = null;
					for (Node n : options){
						if (gs.getMaze().dist(target, n) + gs.getMaze().dist(pre, n) < best) {
							best = gs.getMaze().dist(target, n) + gs.getMaze().dist(pre, n);
							sel = n;
						}
					}
					dirs[i] = Utilities.getWrappedDirection(curGhost.current, sel, gs.getMaze());
				}
				else dirs[i] = getMaxDir(options, curGhost.current, scorers[i], gs);
				continue;
			}
			if (roots[i] == null) { // If the roots is not decided yet
				roots[i] = new LinkedList<TreeNode>();
				TreeNode t = new TreeNode(i,juncs[maze.ghostStart().nodeIndex],NEUTRAL,NEUTRAL);
				t.expand(maze, juncs);
				trees[i] = t.selectedNodesFinal();
				// Get direction for next move
				dirs[i] = trees[i].get(1).dir4Parent;
				//if (i == 0) dirs[i] = rand.nextInt(dx.length >> 2) << 2 + 1;
				//else dirs[i] = (dirs[i-1] + 2) % 4;
				
			} 
			// Stop MCTS
			else if (curGhost.current.adj.size() > 2 && !curGhost.returning() && !(gs.getTotalGameTicks()%2 == 0 && curGhost.edible())){
				if (mctThread[i] != null) mctThread[i].die();
				//if (mctThread[i + nGhosts] != null) mctThread[i + nGhosts].die();
				for (TreeNode r : roots[i]){
					if (r.node.node == curGhost.current && r.dir2Parent == Utilities.getDirection(curGhost.current, curGhost.previous)){
						// If the node isn't visited enough, choose as default
						if (r.nVisits < 10){
							//GhostState gh = gs.getGhosts()[i];
				            dirs[i] = getDefaultDir(gs, i);
				            continue;
						}
						// Decide next move
						trees[i] = r.selectedNodesFinal();
						// If some how the next move is not calculate, skip
						if (trees[i].size() < 2){
							//dirs[i] = rand.nextInt(dx.length);
							dirs[i] = getDefaultDir(gs, i);
							continue;
						}
						// Get direction for next move
						dirs[i] = trees[i].get(1).dir4Parent;
					}
				}
				nextTNode[i] = null;
				roots[i] = new LinkedList<TreeNode>();
			}
		}
		
		//KNN Testing
		if (pac.x % 4 == 3 && pac.y % 4 == 1 && sampleData.size() > 10){
			//System.out.println(t);
			allTimes++;
			if (expectPac != null && expectPac != gs.getPacman().current) 
				falseTimes++;
			PacInfo tmpInfo = new PacInfo(infoCollector);
			KNNAgent pseAgent = new 
				KNNAgent(tmpInfo, sampleData.toArray(new VectorND[0]), procData.toArray(new VectorND[0]), trustLvl);
			int expectDir = pseAgent.getAction(new SimGameState(gs));
			expectPac = gs.getPacman().current;
			for (int j = 0; j < 4; j++){
				if(maze.getNode(expectPac.x + dx[expectDir], expectPac.y + dy[expectDir]) != null)
					expectPac = maze.getNode(expectPac.x + dx[expectDir], expectPac.y + dy[expectDir]);
			}
		}
		
		// Start new MCTS
		for (int i = 0; i < nGhosts; i++){
			// KNN
			if (i == 0) continue;
			KNNAgent pseAgent = null;
			//if ((gs.getGameTick() + 2) % 4 == 0 && sampleData[i].size() > 1){
			if (pac.x % 4 == 3 && pac.y % 4 == 1 && sampleData.size() > 5){
				//allTimes[i]++;
				//if (expectPac[i] != null && expectPac[i] != gs.getPacman().current) 
				//	falseTimes[i]++;
				//pseAgent = new 
				//	KNNAgent(infoCollector[i], sampleData[i].toArray(new VectorND[0]), procData[i].toArray(new VectorND[0]), trustLvl[i]);
				//int expectDir = pseAgent.action(gs);
				//expectPac[i] = gs.getPacman().current;
				//for (int j = 0; j < 4; j++){
				//	if(maze.getNode(expectPac[i].x + dx[expectDir], expectPac[i].y + dy[expectDir]) != null)
				//		expectPac[i] = maze.getNode(expectPac[i].x + dx[expectDir], expectPac[i].y + dy[expectDir]);
				//}
				PacInfo tmpInfo = new PacInfo(infoCollector);
				pseAgent = new 
					KNNAgent(tmpInfo, sampleData.toArray(new VectorND[0]), procData.toArray(new VectorND[0]), trustLvl*(1-1.0*falseTimes/allTimes));
			}
			// Assume the next game state
			SimGameState nextGS = TreeNode.getStartState(trees, gs.copy(), i, pseAgent);
			// Check if the next destination is ok else add new destination
			// If the dest is difference stop, start new Thread
			// Check if at a cross point, start new thread
			// Maybe rootId is not neccessary
			if(nextGS.getPills().isEmpty() && nextGS.getPowers().isEmpty() || nextGS.terminal()) {
				continue;
			}
			//pseAgent = null;
			SimGhosts curGhost = nextGS.getGhosts()[i];
			int curDir = Utilities.getDirection(curGhost.current, curGhost.previous);
			//Stat game state should be put in the thread
			//int curDir = curGhost.curDir;
			if (nextTNode[i] == null || nextTNode[i].node.node != curGhost.current || nextTNode[i].dir2Parent != curDir){
				boolean check = true; //Check wether the nextTNode is already in list or not
				if (mctThread[i] != null) mctThread[i].die();
				//if (mctThread[i + nGhosts] != null) mctThread[i + nGhosts].die();
				for (TreeNode r : roots[i]){
					if (r.node.node == curGhost.current && r.dir2Parent == curDir){
						nextTNode[i] = r;
						mctThread[i] = new MCTThread(gs.copy(), nextTNode[i], i, pseAgent, this);
						mctThread[i].start();
						//mctThread[i + nGhosts] = new MCTThread(nextGS, nextTNode[i], i, pseAgent, this);
						//mctThread[i + nGhosts].start();
						check = false;
						break;
					}
				}
				if (check && juncs[curGhost.current.nodeIndex] != null){
					TreeNode newNode = new TreeNode(i, juncs[curGhost.current.nodeIndex], curDir, NEUTRAL);
					roots[i].add(newNode);
					nextTNode[i] = newNode;
					mctThread[i] = new MCTThread(gs.copy(), nextTNode[i], i, pseAgent, this);
					mctThread[i].start();
					//mctThread[i + nGhosts] = new MCTThread(nextGS, nextTNode[i], i, pseAgent, this);
					//mctThread[i + nGhosts].start();
				}
			}
		}
		/*
		if (gs.terminal() || gs.getPills().isEmpty() && gs.getPowers().isEmpty() || gs.agentDeath()) {
			for (int i=0; i<nGhosts; i++) mctThread[i].die();
		}
		*/
		
		return dirs;
	}
	
	public MyGhostsTeamBot() {
		roots = (List<TreeNode>[]) new List[nGhosts];
		trees = (List<TreeNode>[]) new List[nGhosts];
		//rootId = new int[nGhosts];
		nextTNode = new TreeNode[nGhosts];
		mctThread = new MCTThread[nGhosts*2];
		mainThread = Thread.currentThread();
		
		//startDirs = new int[nGhosts];
		
		//options = new ArrayList<Node>();
        scorers = new NodeScore[]{
        		new PathScore(), new EuclideanScore(),
                new ManhattanScore(), new PathScore()
        };
		
        //Setup for KNNAgent
        /*
        infoCollector = new PacInfo[nGhosts];
        for (int i = 0; i < nGhosts; i++){
        	infoCollector[i] = new PacInfo();
        }
        */
        infoCollector = new PacInfo();
        //sampleData = new LinkedList[nGhosts];
        //procData = new LinkedList[nGhosts];
        //allTimes = new int[nGhosts];
        //falseTimes = new int[nGhosts];
        //expectPac = new Node[4];
        
		//PlaySound.disable();
	}
	
	private void setMaze(MazeInterface maze) {
		this.maze = maze;
		//setup junctions 
		juncs = new JunctionNode[maze.getMap().size()];
		for (Node n : maze.getMap()){
			if (n.adj.size() > 2 || n.equals(maze.ghostStart())) juncs[n.nodeIndex] = new JunctionNode(n);
		}
		
	}
	
	private int getMaxDir(ArrayList<Node> nodes, Node cur, NodeScore f, GameStateInterface gs){
		double best = Double.MIN_VALUE;
        // selected current
        Node sel = null;
        for (Node n : nodes) {
            if (f.score(gs, n) > best) {
                best = f.score(gs, n);
                sel = n;
            }
        }
        if (sel == null) return NEUTRAL;
        return Utilities.getWrappedDirection(cur,sel,gs.getMaze());
	}
	
	public void resetAll() {
		roots = (List<TreeNode>[]) new List[nGhosts];
		trees = (List<TreeNode>[]) new List[nGhosts];
		//rootId = new int[nGhosts];
		nextTNode = new TreeNode[nGhosts];
		for(int i = 0; i < nGhosts*2; i++){
			if (mctThread[i] != null) mctThread[i].die();
		}
		mctThread = new MCTThread[nGhosts*2];
			
		//startDirs = new int[nGhosts];
		//Setup for KNNAgent
        sampleData = null;
        procData = null;
        //if (sampleData != null) sampleData.pollLast();
		//allTimes = 0;
        //falseTimes = 0;
        expectPac = null;
        preGS = null;
        
    }
	
	private int getDefaultDir (GameStateInterface gs, int ghostId){
		int dir;
		Ghosts curGhost = gs.getGhosts()[ghostId];
		ArrayList<Node> options = new ArrayList<Node>();
        for (Node n : curGhost.current.adj) {
            // turning back is not a valid option
            if (!n.equals(curGhost.previous)) options.add(n);
        }
        if (!curGhost.edible() || curGhost.edibleTime < maze.dist(curGhost.current, gs.getPacman().current) / 3.0 )
        	dir = Utilities.getMinDir(options, curGhost.current, scorers[ghostId], gs);
        else 
        	dir = getMaxDir(options, curGhost.current, scorers[ghostId], gs);
        return dir;
	}
	/*
	public static void main(String[] args) {
		GameState gs = new GameState();
		gs.reset();
		MCTTeam test = new MCTTeam();
		//ElapsedTimer et = new ElapsedTimer();
		test.setMaze(gs.getMaze());
		//System.out.println(et);
		for (JunctionNode jn : test.juncs){
			if (jn != null) System.out.println(jn.node.x + "\t" + jn.node.y + "\t" + jn.node.ix);
		}
		//GameStateView gsv = new GameStateView(gs);
		//JEasyFrame fr = new JEasyFrame(gsv, "Game State", true);
		//System.out.println(test.juncs.length);
		TreeNode tn = new TreeNode(test.juncs[gs.getMaze().getNode(27, 21).nodeIndex]); 
		tn.expand(gs, test.juncs);
		tn.children[1].expand(gs, test.juncs);
		int i = 0;
		for (JunctionNode t : test.juncs[gs.getMaze().getNode(27, 21).nodeIndex].adjJunc){
			System.out.println("*" + test.juncs[gs.getMaze().getNode(27, 21).nodeIndex].dirs2Adj[i] + "\t" 
					+ test.juncs[gs.getMaze().getNode(27, 21).nodeIndex].dirs4Adj[i++] + "\t" + t.node);
		}
		
		i = 0;
		for (JunctionNode t : test.juncs[gs.getMaze().getNode(39, 21).nodeIndex].adjJunc){
			System.out.println("**" + test.juncs[gs.getMaze().getNode(39, 21).nodeIndex].dirs2Adj[i] + "\t" 
					+ test.juncs[gs.getMaze().getNode(39, 21).nodeIndex].dirs4Adj[i++] + "\t" + t.node);
		}
		for (i = 0; i < 10; i++){
			List<TreeNode> ls = tn.selectedNodes();
			for (TreeNode cur : ls) {
				System.out.println(cur.node.node);
			}
			System.out.println("*****");
		}
		//System.out.println(et);
	}
	*/
	
}
